<script setup lang="ts">
// import { title } from 'process'
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Employee } from '@/types/Employee'

const headers = [
  {
    title: 'ID',
    key: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Tel',
    key: 'tel',
    value: 'tel'
  },
  {
    title: 'Role',
    key: 'roles',
    value: (item: any | Employee) => item.roles.join(',')
  },
  {
    title: 'Status',
    key: 'status',
    value: (item: any | Employee) => item.status.join(',')
  },
  { key: 'actions', sortable: false }
]

const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const initilEmployee: Employee = {
  id: -1,
  name: '',
  tel: '',
  roles: ['Manager'],
  status: ['FullTime'],
  checkIn: '',
  checkOut: '',
  salary: 0,
  date: ''
}
const editedEmployee = ref<Employee>(JSON.parse(JSON.stringify(initilEmployee)))

const employee = ref<Employee[]>([])
let editedIndex = -1
let lastId = 6
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedEmployee.value = Object.assign({}, initilEmployee)
  })
}
function deleteItemConfirm() {
  // Delete item from list
  employee.value.splice(editedIndex, 1)
  closeDelete()
}
function editItem(item: Employee) {
  editedIndex = employee.value.indexOf(item)
  editedEmployee.value = Object.assign({}, item)
  dialog.value = true
}
function deleteItem(item: Employee) {
  editedIndex = employee.value.indexOf(item)
  editedEmployee.value = Object.assign({}, item)
  dialogDelete.value = true
  editedIndex = -1
}
function initialize() {
  employee.value = [
    {
      id: 1,
      name: 'Toge Inumaki',
      tel: '0891234508',
      roles: ['Manager'],
      status: ['PartTime', 'FullTime'],
      checkIn: '07.45.34',
      checkOut: '16.00.49',
      salary: 30000,
      date: '01/01/2024'
    },
    {
      id: 2,
      name: 'Anya Forger',
      tel: '0891234567',
      roles: ['Staff'],
      status: ['FullTime'],
      checkIn: '07.55.34',
      checkOut: '16.10.51',
      salary: 15000,
      date: '01/01/2024'
    },
    {
      id: 3,
      name: 'Levi Ackerman',
      tel: '0834567891',
      roles: ['Staff'],
      status: ['PartTime'],
      checkIn: '08.05.14',
      checkOut: '16.50.16',
      salary: 15500,
      date: '01/01/2024'
    },
    {
      id: 4,
      name: 'Tobio Kageyama',
      tel: '0871234589',
      roles: ['Staff'],
      status: ['FullTime'],
      checkIn: '07.59.34',
      checkOut: '16.00.44',
      salary: 16000,
      date: '01/01/2024'
    },
    {
      id: 5,
      name: 'Kiyoko Shimizu',
      tel: '0997851234',
      roles: ['Staff'],
      status: ['PartTime'],
      checkIn: '08.45.34',
      checkOut: '17.00.48',
      salary: 18000,
      date: '01/01/2024'
    }
  ]
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedEmployee.value = Object.assign({}, initilEmployee)
    editedIndex = -1
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(employee.value[editedIndex], editedEmployee.value)
  } else {
    editedEmployee.value.id = lastId++
    employee.value.push(editedEmployee.value)
  }
  editedIndex = -1
  closeDialog()
}
onMounted(() => {
  initialize()
})
</script>

<template>
  <div>
    <v-data-table style="background-color: #efe7e1" :headers="headers" :items="employee">
      <template v-slot:top>
        <v-toolbar flat style="color: #f5f3ef; background-color: #8b7565">
          <v-toolbar-title>Employee Management</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog-->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <!-- <v-btn
                style="color: #00a300; background-color: #f9f8f5"
                class="custom-button"
                v-bind="props"
                prepend-icon="mdi-currency-usd"
              >
                Salary
              </v-btn> -->
              <v-btn
                style="color: #0043c7; background-color: #f9f8f5"
                class="custom-button"
                v-bind="props"
                prepend-icon="mdi-plus"
              >
                New Employee
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Employee Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="6">
                        <v-text-field
                          v-model="editedEmployee.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field
                      ></v-col>
                      <v-col cols="12" sm="6"
                        ><v-text-field
                          v-model="editedEmployee.tel"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Tel"
                        ></v-text-field
                      ></v-col>
                      <v-col cols="12" sm="6"
                        ><v-combobox
                          label="Select role"
                          :items="['Manager', 'Staff']"
                          v-model="editedEmployee.roles"
                          multiple
                          :return-object="false"
                        ></v-combobox
                      ></v-col>
                      <v-col cols="12" sm="6"
                        ><v-combobox
                          label="Select status"
                          :items="['FullTime', 'PartTime']"
                          v-model="editedEmployee.status"
                          multiple
                          :return-object="false"
                        ></v-combobox
                      ></v-col>
                      <!-- <v-col cols="12" sm="6">
                        <v-text-field
                          v-model="editedEmployee.checkIn"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="CheckIn (Format: XX.XX.XX)"
                        ></v-text-field
                      ></v-col>
                      <v-col cols="12" sm="6">
                        <v-text-field
                          v-model="editedEmployee.checkOut"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="CheckOut (Format: XX.XX.XX)"
                        ></v-text-field
                      ></v-col>
                      <v-col cols="12" sm="6">
                        <v-text-field
                          v-model="editedEmployee.salary"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Salary (Only Number)"
                        ></v-text-field
                      ></v-col> -->
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="#81322c" class="me-2" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" color="#81322c" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="initialize"> Reset </v-btn>
      </template></v-data-table
    >
  </div>
</template>

<style>
.custom-button {
  margin: 5px; /* เว้นระยะห่าง */
  border-radius: 20px; /* make the roundness */
  padding: 10px 20px;
}
</style>
